<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8"/>
	<meta type="Content-type" content="text/html;charset=UTF-8" />
	<title>排序算法</title>
	<style type="text/css"></style>
</head>
<body>
	<script type="text/javascript">
		/*Array.sort*/
		const arr1 = [1,20,10,30,22,11,55,24,31,88,12,100,50];
		console.log(arr1.sort());
		console.log(arr1.sort((item1,item2)=>item1-item2));
		/*冒泡排序*/
		const arr2 = [1,20,10,30,22,11,55,24,31,88,12,100,50];
		function swap(arr,i,j){
			var temp=arr[i];
				arr[i]=arr[j];
				arr[j]=temp;
		};
		function bubbleSort(arr){
			for(var i=0;i<arr.length-1;i++){
				for(var j=0;j<arr.length-i-1;j++){
					if(arr[j]>arr[j+1]){
						swap(arr,j,j+1);
					}
				}
			}
			return arr;
		} 
		console.log(bubbleSort(arr2));
		function swap(arr, i, j){
		    const temp = arr[i];
		    arr[i] = arr[j];
		    arr[j] = temp;
		};
		function bubbleSort2(arr){
			for(let i =0; i < arr.length -1; i++){
			    let flag =false;
			    for(let j =0; j < arr.length -1- i; j++){
			        if(arr[j] > arr[j+1]){
			            swap(arr, j, j+1);
			            flag =true;
			        }
			    }
			    if(!flag){
			        break;
			    }
			}
			return arr;
		}; 
		console.log(bubbleSort2(arr2));
		function swap(arr, i, j){
		    let temp = arr[i];
		    arr[i] = arr[j];
		    arr[j] = temp
		};
		function improveBubble(arr, len){
		    for(let i = len -1; i >=0; i--){
		       let pos =0;
		        for(let j =0; j < i; j++){
		            if(arr[j] > arr[j+1]){
		               swap(arr, j, j+1);
		               pos = j +1;
		             }
		       }
		       len = pos +1;
		    }
		    return arr;
		};
		console.log(improveBubble(arr2, arr2.length));
		/*选择排序*/
		
	</script>
</body>
</html>